$activeUser = nil

class User
  attr :id ,true
  attr :name ,true
  attr :password ,true
  attr :fullName ,true
  attr :area ,true
  attr :roleArray ,true
  def initialize
	@roleArray = Array.new
  end
end

class Role
  attr :projectId ,true
  attr :roleType ,true
end

class UserManager
    private
    #@return -9999 the username is not found. -9998 the password is not correct. 0 login ok.
    def checkLogin(username, password)
        filename         = "userAttributes.csv"
        path             = "Plugins/CRSD/Definitions/"
        userInformations = getUsersInfoFromFile(filename, path)
        i                = 1
        len              = userInformations.length
        while i < len
            if (userInformations[i][1] == username)
                if (userInformations[i][2] == password)
                    user          = User.new
                    user.name     = username
                    user.password = password
                    user.fullName = userInformations[i][3]
                    user.area     = userInformations[i][4]
                    projectAll    = userInformations[i][5]
                    roleAll       = userInformations[i][6]
                    projectArray  = projectAll.split('#')
                    roleArray     = roleAll.split('#')
                    roles         = Array.new
                    idx           = 0
                    while idx < projectAll.length
                        role           = Role.new
                        role.projectId = projectArray[idx]
                        role.roleType  = roleArray[idx]
                        user.roleArray << role
                        idx = idx + 1
                    end
                    $activeUser          = user
                    return 0
                else
                    return -9998
                end
            end
            i += 1
        end
        return -9999
    end

    public

    def login()
        webDialog = UI::WebDialog.new('login', true, nil, 20, 25, 0, 0, true);
        webDialog.set_size(420, 240)

        mainPage = Sketchup.find_support_file "CRSD/Web/Login.html", "Plugins"
        webDialog.set_file mainPage
		
		webWidth = 280
		webHeight = 200
		webDialog.set_size webWidth, webHeight
        webDialog.min_width = webWidth
        webDialog.min_height = webHeight
        webDialog.max_width = webWidth * 1.5
        webDialog.max_height = webHeight * 1.5

        webDialog.add_action_callback("login") { |dialog, arg|
            strArray = arg.split("|")
            user = nil
            pwd  = nil
            strArray.each { |e|
                commIdx = e.index(":")
                if  (commIdx)
                    key = e[0, commIdx]
                    val = e[commIdx + 1, e.length]
                    if ("user".upcase == key.upcase)
                        user = val
                    end
                    if ("password".upcase == key.upcase)
                        pwd = val
                    end
                end
            }

            ret = checkLogin(user, pwd)
            if (ret == -9999)
                UI.messagebox '用户名[' + user + '] 不存在！'
            elsif (ret == -9998)
                UI.messagebox '用户名密码不匹配！'
            else
                webDialog.close()
            end
        }
        webDialog.show_modal { }
    end

    # check the login user has the permission or not.
    # designer#checker#projectManager#majorManager
    def hasPermission(username, projectname, roleType)
        $acitveUser.roleArray.each { |e|
            if (e.projectId == projectname)
                roles = 'designer#checker#projectManager#majorManager'
                idx   = roles.index(e.roleType)
                str   = roles[0, idx]
                if (str != nil && str.index(roleType) != nil)
                    return true
                end
            end
        }
        return false
    end
	
	
	def getUsersInfoFromFile(fileName, path)
        arrayAttributes = Array.new
        pathAttrFile = Sketchup.find_support_file fileName, path
        if (pathAttrFile)
            fileAttr = File.open pathAttrFile,"r"
            arrayFileLines = fileAttr.readlines

            arrayFileLines.each do|fileline|
                arrayFileLine = fileline.split ","
                arrayAttributes << arrayFileLine
            end
            fileAttr.close
        end
        return arrayAttributes
    end
	
	def roleSwitch(roleType,type)
		strArray = ["Surveyor","Designer","Checker","MajorManager","IndividualProjectManager",
					"ProjectManager","Approver","Inspector"]
		numArray = [SURVEYOR,DESIGNER,CKECKER,MAJOR_MANAGER,INDIVIDUAL_PROJECT_MANAGER,
					PROJECT_MANAGER,APPROVER,INSPECTOR]
		
		if roleType == nil
			puts "UserManager.roleSwitch: The roleType is nil."
			return false
		else
			if type == STRING
				i = 0 
				while i < numArray.length
					if numArray[i] == roleType
						return strArray[i]
					end
					i += 1
				end
			else
				i = 0 
				while i < numArray.length
					if strArray[i] == roleType
						return numArray[i]
					end
					i += 1
				end
			end
		end
		puts "UserManager.roleSwitch: Fail to Switch the roleType."
		return roleType
		
	end
	
end